Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## fr.gouv.culture.sdx.search.lucene.queryparser
Class ZeroPositionIncrementTokenQueryParser

    java.lang.Object
      fr.gouv.culture.sdx.search.lucene.queryparser.ZeroPositionIncrementTokenQueryParser

All Implemented Interfaces:
  QueryParser, QueryParser, ZeroPositionIncrementTokenQueryParserConstants

public class ZeroPositionIncrementTokenQueryParser
extends java.lang.Object
implements QueryParser, ZeroPositionIncrementTokenQueryParserConstants

This class is generated by JavaCC. The only method that clients should need to call is parse(). The syntax for query strings is as follows: A Query is a series of clauses. A clause may be prefixed by:

- a plus (`+`) or a minus (`-`) sign, indicating that the clause is required or prohibited respectively; or
- a term followed by a colon, indicating the field to be searched. This enables one to construct queries which search multiple fields.

A clause may be either:

- a term, indicating all the documents that contain this term; or
- a nested query, enclosed in parentheses. Note that this may be used with a `+`/`-` prefix to require any of a set of terms.

Thus, in BNF, the query grammar is:

       Query  ::= ( Clause )*
       Clause ::= ["+", "-"] [<TERM> ":"] ( <TERM> | "(" Query ")" )

Examples of appropriately formatted queries can be found in the test cases.

Author:
  Brian Goetz, Peter Halacsy, Tatu Saloranta

Field Summary
`static int` | `DEFAULT_OPERATOR_AND`
`static int` | `DEFAULT_OPERATOR_OR`
`Token` | `jj_nt`
`boolean` | `lookingAhead`
`SearchLocations` | `sLocs`
`Token` | `token`
`ZeroPositionIncrementTokenQueryParserTokenManager` | `token_source`

Fields inherited from interface fr.gouv.culture.sdx.search.lucene.queryparser.QueryParser
`DEFAULT_OPERATOR, DEFAULT_PHRASE_SLOP, OPERATOR_AND, OPERATOR_OR`

Fields inherited from interface fr.gouv.culture.sdx.search.lucene.queryparser.ZeroPositionIncrementTokenQueryParserConstants
`_ESCAPED_CHAR, _NUM_CHAR, _TERM_CHAR, _TERM_START_CHAR, _WHITESPACE, AND, Boost, CARAT, COLON, DEFAULT, EOF, FUZZY, LPAREN, MINUS, NO_ANALYSIS, NOT, NUMBER, OR, PLUS, PREFIXTERM, QUOTED, RangeEx, RANGEEX_END, RANGEEX_GOOP, RANGEEX_QUOTED, RANGEEX_START, RANGEEX_TO, RangeIn, RANGEIN_END, RANGEIN_GOOP, RANGEIN_QUOTED, RANGEIN_START, RANGEIN_TO, RPAREN, SLOP, TERM, tokenImage, WILDTERM`

Constructor Summary
`ZeroPositionIncrementTokenQueryParser()` Constructs a query parser.
`ZeroPositionIncrementTokenQueryParser(CharStream stream)`
`ZeroPositionIncrementTokenQueryParser(java.lang.String f, Analyzer a)` Constructs a query parser.
`ZeroPositionIncrementTokenQueryParser(ZeroPositionIncrementTokenQueryParserTokenManager tm)`

Method Summary
`protected void` | `addClause(java.util.Vector clauses, int conj, int mods, org.apache.lucene.search.Query q)`
`org.apache.lucene.search.Query` | `Clause(java.lang.String field)`
`int` | `Conjunction()`
`void` | `disable_tracing()`
`void` | `enable_tracing()`
`ParseException` | `generateParseException()`
`protected org.apache.lucene.search.Query` | `getBooleanQuery(java.util.Vector clauses)` Factory method for generating query, given a set of clauses.
`protected org.apache.lucene.search.Query` | `getFieldQuery(java.lang.String field, Analyzer analyzer, java.lang.String queryText)`
`protected org.apache.lucene.search.Query` | `getFuzzyQuery(java.lang.String field, java.lang.String termStr)` Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`).
`java.util.Locale` | `getLocale()` Returns current locale, allowing access by subclasses.
`boolean` | `getLowercaseWildcardTerms()`
`Token` | `getNextToken()`
`int` | `getOperator()` Gets implicit operator setting, which will be either DEFAULT_OPERATOR_AND or DEFAULT_OPERATOR_OR.
`int` | `getPhraseSlop()` Gets the default slop for phrases.
`protected org.apache.lucene.search.Query` | `getPrefixQuery(java.lang.String field, java.lang.String termStr)` Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`).
`protected org.apache.lucene.search.Query` | `getRangeQuery(java.lang.String field, Analyzer analyzer, java.lang.String part1, java.lang.String part2, boolean inclusive)`
`Token` | `getToken(int index)`
`protected org.apache.lucene.search.Query` | `getUnanalyzedQuery(java.lang.String field, java.lang.String queryText)`
`protected org.apache.lucene.search.Query` | `getWildcardQuery(java.lang.String field, java.lang.String termStr)` Factory method for generating a query.
`static void` | `main(java.lang.String[] args)`
`int` | `Modifiers()`
`org.apache.lucene.search.Query` | `parse(java.lang.String query)` Parses a query string, returning a Query.
`static org.apache.lucene.search.Query` | `parse(java.lang.String query, java.lang.String field, Analyzer analyzer)` Parses a query string, returning a `Query`.
`org.apache.lucene.search.Query` | `Query(java.lang.String field)`
`void` | `ReInit(CharStream stream)`
`void` | `ReInit(ZeroPositionIncrementTokenQueryParserTokenManager tm)`
`void` | `setLocale(java.util.Locale locale)` Set locale used by date range parsing.
`void` | `setLowercaseWildcardTerms(boolean lowercaseWildcardTerms)`
`void` | `setOperator(int operator)` Sets the boolean operator of the QueryParser.
`void` | `setPhraseSlop(int phraseSlop)` Sets the default slop for phrases.
`void` | `setUp(Analyzer a, int phraseSlop, int operator)` Sets the fields of the query parser
`void` | `setUp(java.lang.String f, Analyzer a)` Sets the fields of the query parser
`void` | `setUp(java.lang.String f, Analyzer a, int phraseSlop, int operator)` Sets the fields of the query parser
`void` | `setUp(java.lang.String f, Analyzer a, SearchLocations sl, int phraseSlop, int operator)` Sets the fields of the query parser
`org.apache.lucene.search.Query` | `Term(java.lang.String field)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_OPERATOR_OR

    public static final int DEFAULT_OPERATOR_OR

See Also:
  Constant Field Values

### DEFAULT_OPERATOR_AND

    public static final int DEFAULT_OPERATOR_AND

See Also:
  Constant Field Values

### sLocs

    public SearchLocations sLocs

### token_source

    public ZeroPositionIncrementTokenQueryParserTokenManager token_source

### token

    public Token token

### jj_nt

    public Token jj_nt

### lookingAhead

    public boolean lookingAhead

Constructor Detail

### ZeroPositionIncrementTokenQueryParser

    public ZeroPositionIncrementTokenQueryParser()

  Constructs a query parser.

### ZeroPositionIncrementTokenQueryParser

    public ZeroPositionIncrementTokenQueryParser(java.lang.String f,
                                                 Analyzer a)

  Constructs a query parser.

Parameters:
  `f` - the default field for query terms.
  `a` - used to find terms in the query text.

### ZeroPositionIncrementTokenQueryParser

    public ZeroPositionIncrementTokenQueryParser(CharStream stream)

### ZeroPositionIncrementTokenQueryParser

    public ZeroPositionIncrementTokenQueryParser(ZeroPositionIncrementTokenQueryParserTokenManager tm)

Method Detail

### parse

    public static org.apache.lucene.search.Query parse(java.lang.String query,
                                                       java.lang.String field,
                                                       Analyzer analyzer)
                                                throws ParseException

  Parses a query string, returning a `Query`.

  Parameters:
    `query` - the query string to be parsed.
    `field` - the default field for query terms.
    `analyzer` - used to find terms in the query text.
  Throws:
    `ParseException` - if the parsing fails

### setUp

    public void setUp(java.lang.String f,
                      Analyzer a)

  Sets the fields of the query parser

  Specified by:
    `setUp` in interface `QueryParser`
  Parameters:
    `f` - the default field for query terms.
    `a` - used to find terms in the query text.

### setUp

    public void setUp(Analyzer a,
                      int phraseSlop,
                      int operator)

  Sets the fields of the query parser

  Specified by:
    `setUp` in interface `QueryParser`
  Parameters:
    `a` - used to find terms in the query text.
    `phraseSlop` - the slop
    `operator` - the operator

### setUp

    public void setUp(java.lang.String f,
                      Analyzer a,
                      int phraseSlop,
                      int operator)

  Sets the fields of the query parser

  Specified by:
    `setUp` in interface `QueryParser`
  Parameters:
    `f` - the default field for query terms.
    `a` - used to find terms in the query text.
    `phraseSlop` - the slop
    `operator` - the operator

### setUp

    public void setUp(java.lang.String f,
                      Analyzer a,
                      SearchLocations sl,
                      int phraseSlop,
                      int operator)

  Sets the fields of the query parser

  Specified by:
    `setUp` in interface `QueryParser`
  Parameters:
    `f` - the default field for query terms.
    `a` - used to find terms in the query text.
    `sl` - SearchLocations
    `phraseSlop` - the slop
    `operator` - the operator

### parse

    public org.apache.lucene.search.Query parse(java.lang.String query)
                                         throws ParseException

  Parses a query string, returning a Query.

  Specified by:
    `parse` in interface `QueryParser`
  Parameters:
    `query` - the query string to be parsed.
  Throws:
    `ParseException` - if the parsing fails

### setPhraseSlop

    public void setPhraseSlop(int phraseSlop)

  Sets the default slop for phrases. If zero, then exact phrase matches are required. Default value is zero.

  Specified by:
    `setPhraseSlop` in interface `QueryParser`

### getPhraseSlop

    public int getPhraseSlop()

  Gets the default slop for phrases.

  Specified by:
    `getPhraseSlop` in interface `QueryParser`

### setOperator

    public void setOperator(int operator)

  Sets the boolean operator of the QueryParser. In classic mode (`DEFAULT_OPERATOR_OR`) terms without any modifiers are considered optional: for example `capital of Hungary` is equal to `capital OR of OR Hungary`.
  In `DEFAULT_OPERATOR_AND` terms are considered to be in conjuction: the above mentioned query is parsed as `capital AND of AND Hungary`

  Specified by:
    `setOperator` in interface `QueryParser`

### getOperator

    public int getOperator()

  Gets implicit operator setting, which will be either DEFAULT_OPERATOR_AND or DEFAULT_OPERATOR_OR.

  Specified by:
    `getOperator` in interface `QueryParser`

### setLowercaseWildcardTerms

    public void setLowercaseWildcardTerms(boolean lowercaseWildcardTerms)

### getLowercaseWildcardTerms

    public boolean getLowercaseWildcardTerms()

### setLocale

    public void setLocale(java.util.Locale locale)

  Set locale used by date range parsing.

### getLocale

    public java.util.Locale getLocale()

  Returns current locale, allowing access by subclasses.

### addClause

    protected void addClause(java.util.Vector clauses,
                             int conj,
                             int mods,
                             org.apache.lucene.search.Query q)

### getFieldQuery

    protected org.apache.lucene.search.Query getFieldQuery(java.lang.String field,
                                                           Analyzer analyzer,
                                                           java.lang.String queryText)
                                                    throws ParseException

  Throws:
    `ParseException` - throw in overridden method to disallow

### getUnanalyzedQuery

    protected org.apache.lucene.search.Query getUnanalyzedQuery(java.lang.String field,
                                                                java.lang.String queryText)

### getRangeQuery

    protected org.apache.lucene.search.Query getRangeQuery(java.lang.String field,
                                                           Analyzer analyzer,
                                                           java.lang.String part1,
                                                           java.lang.String part2,
                                                           boolean inclusive)
                                                    throws ParseException

  Throws:
    `ParseException` - throw in overridden method to disallow

### getBooleanQuery

    protected org.apache.lucene.search.Query getBooleanQuery(java.util.Vector clauses)
                                                      throws ParseException

  Factory method for generating query, given a set of clauses. By default creates a boolean query composed of clauses passed in. Can be overridden by extending classes, to modify query being returned.

  Parameters:
    `clauses` - Vector that contains `BooleanClause` instances to join.
  Returns:
    Resulting `Query` object.
  Throws:
    `ParseException` - throw in overridden method to disallow

### getWildcardQuery

    protected org.apache.lucene.search.Query getWildcardQuery(java.lang.String field,
                                                              java.lang.String termStr)
                                                       throws ParseException

  Factory method for generating a query. Called when parser parses an input term token that contains one or more wildcard characters (? and *), but is not a prefix term token (one that has just a single * character at the end)

  Depending on settings, prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

  Can be overridden by extending classes, to provide custom handling for wildcard queries, which may be necessary due to missing analyzer calls.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token that contains one or more wild card characters (? or *), but is not simple prefix term
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### getPrefixQuery

    protected org.apache.lucene.search.Query getPrefixQuery(java.lang.String field,
                                                            java.lang.String termStr)
                                                     throws ParseException

  Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that uses prefix notation; that is, contains a single '*' wildcard character as its last character. Since this is a special case of generic wildcard term, and such a query can be optimized easily, this usually results in a different query object.

  Depending on settings, a prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

  Can be overridden by extending classes, to provide custom handling for wild card queries, which may be necessary due to missing analyzer calls.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token to use for building term for the query (without trailing '*' character!)
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### getFuzzyQuery

    protected org.apache.lucene.search.Query getFuzzyQuery(java.lang.String field,
                                                           java.lang.String termStr)
                                                    throws ParseException

  Factory method for generating a query (similar to (`getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that has the fuzzy suffix (~) appended.

  Parameters:
    `field` - Name of the field query will use.
    `termStr` - Term token to use for building term for the query
  Returns:
    Resulting `Query` built for the term
  Throws:
    `ParseException` - throw in overridden method to disallow

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### Conjunction

    public final int Conjunction()
                          throws ParseException

  Throws:
    `ParseException`

### Modifiers

    public final int Modifiers()
                        throws ParseException

  Throws:
    `ParseException`

### Query

    public final org.apache.lucene.search.Query Query(java.lang.String field)
                                               throws ParseException

  Throws:
    `ParseException`

### Clause

    public final org.apache.lucene.search.Query Clause(java.lang.String field)
                                                throws ParseException

  Throws:
    `ParseException`

### Term

    public final org.apache.lucene.search.Query Term(java.lang.String field)
                                              throws ParseException

  Throws:
    `ParseException`

### ReInit

    public void ReInit(CharStream stream)

### ReInit

    public void ReInit(ZeroPositionIncrementTokenQueryParserTokenManager tm)

### getNextToken

    public final Token getNextToken()

### getToken

    public final Token getToken(int index)

### generateParseException

    public ParseException generateParseException()

### enable_tracing

    public final void enable_tracing()

### disable_tracing

    public final void disable_tracing()

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2007 Ministere de la culture et de la communication / AJLSM. All Rights Reserved.